@echo off
set scriptDebug=0
if "%scriptDebug%" == "0" goto echoOff
@echo on

:echoOff
set pathsave=%path%
 
if "%BASEDIR%"=="" goto no_basedir

set path=%path%;%BASEDIR%\bin

if "%1" == "" goto noMode
set mode=%1
shift
if "%mode%" == "freesd" goto setsd
goto callsetenv

:setsd
@echo enabling symbols in free build
set mode=free
pushd .
call %BASEDIR%\bin\setenv.bat %BASEDIR% %mode%
popd

rem reset debugging vars
set NTDEBUGTYPE=windbg
set NTDEBUG=ntsd
goto checkDir

:noMode
set mode=checked

:callsetenv
pushd .
call %BASEDIR%\bin\setenv.bat %BASEDIR% %mode%
popd

:checkDir
if "%1" == "" goto noDir
if EXIST %1 goto dirOK

@echo Error: directory %1 does not exist
goto usage

:noDir
@echo Error: no directory specified
:usage
echo usage: ddkbuild "checked | free" "directory-to-build" nt|w2k|wxp 
goto end

:dirOK

if "%NUMBER_OF_PROCESSORS"=="" goto no_mp
set mpFlag=-M
goto mp_done

:no_mp
set mpFlag=""

:mp_done

if "%2"=="" goto no_args
set VER=%2
goto doit

:no_args
echo Must specify which version you are building
goto end

:doit

echo build in directory %1 version %2 (basedir %BASEDIR%)

pushd %1
set bflags=-e

if "%2" == "" goto noaddflags

set bflags=%2%e

:noaddflags


:done

if EXIST build.err	erase build.err
if EXIST build.wrn      erase build.wrn
if EXIST build.log	erase build.log

echo run build %bflags% %mpFlag% for %mode% version in %1
pushd .
build  %bflags% %mpFlag%
popd

rem assume that the onscreen errors are complete!

echo =============== build warnings ======================
if not exist build.log goto complete

findstr "warning.*[CL][0-9]*" build.log

echo. 
echo. 

:complete
echo build complete
goto doBrowse

:no_basedir
@echo Error: BASEDIR not set
goto usage

:doBrowse

echo building browse information files

if EXIST sbrList.txt goto bscList

popd
goto end

:bscList
bscmake @sbrList.txt
popd

:end
echo ddkbuild complete
set path=%pathsave%

